﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;
using C1.Win.C1FlexGrid;
using System.Globalization;
using System.Collections;
using System.Collections.Specialized;
using System.Drawing.Imaging;
using System.Diagnostics;
using C1.Win.C1Ribbon;

using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : C1RibbonForm
    {
        private List<DictionaryEntry> category;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.dateTimePicker1.Value = DateTime.Now;
            this.initializeCategory();
            this.initializeGrandTotal();
        }

        private void dateTimePicker1_ValueChanged(object sender, EventArgs e)
        {
            //this.loadDatabase();
        }

        /// <summary>
        /// Returns the connection string of the database.
        /// </summary>
        /// <returns></returns>
        private string getConnectionString()
        {
            string connectionString = string.Empty;
            connectionString += "Data Source = (local)\\Developer2005;";
            connectionString += "Initial Catalog = CodeZine;";
            connectionString += "Integrated Security = SSPI;";

            return connectionString;
        }

        /// <summary>
        /// Set the intial value of aggregate row.
        /// </summary>
        private void initializeGrandTotal()
        {
            this.c1FlexGrid1.Tree.Column = 1;
            this.c1FlexGrid1.Tree.Style = TreeStyleFlags.Simple;

            // Clear the already existing subtotal values.
            this.c1FlexGrid1.Subtotal(AggregateEnum.Clear);

            // Set the cell style for the grandtotal row.
            CellStyle cellStyle = this.c1FlexGrid1.Styles[CellStyleEnum.GrandTotal];
            cellStyle.BackColor = Color.Blue;
            cellStyle.ForeColor = Color.White;
            cellStyle.Font = new Font(Font, FontStyle.Bold);

            // Set the cell style for the subtotal row. 
            cellStyle = this.c1FlexGrid1.Styles[CellStyleEnum.Subtotal0];
            cellStyle.BackColor = Color.Orchid;
            cellStyle.ForeColor = Color.White;
            cellStyle.Font = new Font(Font, FontStyle.Bold);
        }

        /// <summary>
        /// Set the intial values for Category.
        /// </summary>
        private void initializeCategory()
        {
            SqlConnection connection = new SqlConnection(this.getConnectionString());

            // Open database connection.
            connection.Open();

            // Generate an instance of SqlCommand from SqlConnection.  
            SqlCommand command = connection.CreateCommand();

            // Set the SQL command to be executed.
            command.CommandText = "SELECT CategoryCode, CategoryName FROM CategoryMaster ORDER BY CategoryCode";

            // Run the SQL command and create SqlDataReader. 
            SqlDataReader reader = command.ExecuteReader();

            // Dispose command.
            command.Dispose();

            this.category = new List<DictionaryEntry>();

            // Go to the next record.
            while (reader.Read())
            {
                this.category.Add(new DictionaryEntry(reader["CategoryCode"], reader["CategoryName"]));
            }

            // Close reader.
            reader.Close();

            // Close the database connection. 
            connection.Close();
            connection.Dispose();

            ListDictionary dictionary = new ListDictionary();

            foreach(DictionaryEntry entry in this.category )
            {
                dictionary.Add(entry.Key, entry.Value);
            }

            this.c1FlexGrid1.Cols[1].DataType = typeof(int);
            this.c1FlexGrid1.Cols[1].DataMap = dictionary;
        }

        /// <summary>
        /// Display the aggregate row. 
        /// </summary>
        private void showTotal()
        {
            // Clear subtotal. 
            this.c1FlexGrid1.Subtotal(AggregateEnum.Clear);

            // Sort the contents of the grid.
            this.c1FlexGrid1.Sort(SortFlags.Ascending, 0, 1);

            // Calculate the grandtotal. 
            this.c1FlexGrid1.Subtotal(AggregateEnum.Sum, -1, -1, 2, "Total");
            this.c1FlexGrid1.Subtotal(AggregateEnum.Sum, -1, -1, 3, "Total");
            this.c1FlexGrid1.Subtotal(AggregateEnum.Sum, -1, -1, 4, "Total");
            //this.c1FlexGrid1.Subtotal(AggregateEnum.Average, -1, -1, 5, "Total");

            // Calculate the subtotal. 
            this.c1FlexGrid1.Subtotal(AggregateEnum.Sum, 0, 0, 2, "{0:MM/dd} Subtotal");
            this.c1FlexGrid1.Subtotal(AggregateEnum.Sum, 0, 0, 3, "{0:MM/dd} Subtotal");
            this.c1FlexGrid1.Subtotal(AggregateEnum.Sum, 0, 0, 4, "{0:MM/dd} Subtotal");
        }

        /// <summary>
        /// Print the contents of the grid. 
        /// </summary>
        private void printGrid()
        {
            // Set page setting for printing. (Portrait) 
            this.c1FlexGrid1.PrintParameters.PrintDocument.DefaultPageSettings.Landscape = false;
            
            // Set the margin on the left of the document. 
            this.c1FlexGrid1.PrintParameters.PrintDocument.DefaultPageSettings.Margins.Left = 150;

            // Set header and footer font.
            this.c1FlexGrid1.PrintParameters.HeaderFont
                = new Font("Arial Narrow", 10, FontStyle.Regular);
            this.c1FlexGrid1.PrintParameters.FooterFont
                = new Font("Arial Narrow", 8, FontStyle.Italic);

            // Get the preview of the grid.
            string title = string.Format("Sales Data for {0}", CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(this.dateTimePicker1.Value.Month));
            this.c1FlexGrid1.PrintGrid(title,
                PrintGridFlags.FitToPage | PrintGridFlags.ShowPreviewDialog,
                title,
                (char)(9) + "" + (char)(9) + "Page {0}/{1}");
        }

        

        /// <summary>
        /// Write the values to the database. 
        /// </summary>
        private void writeDatabase()
        {
            SqlConnection connection = new SqlConnection(this.getConnectionString());

            // Open database connection. 
            connection.Open();

            SqlCommand command = new SqlCommand();
            command.Connection = connection;
            command.CommandType = CommandType.Text;

            // Delete data. 
            DateTime selectedMonth
                = new DateTime(this.dateTimePicker1.Value.Year, this.dateTimePicker1.Value.Month, 1);

            command.CommandText =
                string.Format("DELETE FROM Sales WHERE Date >= '{0}' AND Date < '{1}'",
                selectedMonth,
                selectedMonth.AddMonths(1));
            command.ExecuteNonQuery();

            for (int i = 1; i < this.c1FlexGrid1.Rows.Count; i++)
            {
                if ( this.c1FlexGrid1[i, 0] != null 
                    && (this.c1FlexGrid1[i, 2] != null
                    || this.c1FlexGrid1[i, 3] != null) )
                {
                    string insert =
                        string.Format("INSERT Sales (Date, CategoryCode, Proceeds, Payments, GrossMargin, GrossMarginRate) VALUES ('{0}', {1}, {2}, {3}, {4}, {5})",
                        this.c1FlexGrid1[i, 0],
                        this.c1FlexGrid1[i, 1] == null ? 0 : this.c1FlexGrid1[i, 1],
                        this.c1FlexGrid1[i, 2] == null ? 0 : this.c1FlexGrid1[i, 2],
                        this.c1FlexGrid1[i, 3] == null ? 0 : this.c1FlexGrid1[i, 3],
                        this.c1FlexGrid1[i, 4],
                        this.c1FlexGrid1[i, 5]);

                    command.CommandType = CommandType.Text;
                    command.CommandText = insert;
                    command.ExecuteNonQuery();
                }
            }

            // Dispose command. 
            command.Dispose();

            // Close database connection. 
            connection.Close();
            connection.Dispose();
        }

        /// <summary>
        /// Get database values. 
        /// </summary>
        private void loadDatabase()
        {
            SqlConnection connection = new SqlConnection(this.getConnectionString());

            // Open database connection. 
            connection.Open();

            // Generate an instance of SqlCommand from SqlConnection.
            SqlCommand command = connection.CreateCommand();

            DateTime selectedMonth
                = new DateTime(this.dateTimePicker1.Value.Year, this.dateTimePicker1.Value.Month, 1);

            string selectSQL
                = string.Format("SELECT Date, CategoryCode, Proceeds, Payments, GrossMargin, GrossMarginRate FROM Sales"
                                    + " WHERE Date >= '{0}' AND Date < '{1}'"
                                    + " ORDER BY Date, CategoryCode", selectedMonth, selectedMonth.AddMonths(1));

            // Set the SQL command to be executed. 
            command.CommandText = selectSQL;

            // Run the SQL command and create SqlDataReader.
            SqlDataReader reader = command.ExecuteReader();

            // Dispose command.
            command.Dispose();

            this.c1FlexGrid1.Rows.RemoveRange(1, this.c1FlexGrid1.Rows.Count - 1);

            // Go to the next record. 
            while (reader.Read())
            {
                this.c1FlexGrid1.AddItem(new object[] { reader["Date"], reader["CategoryCode"], reader["Proceeds"], reader["Payments"], reader["GrossMargin"], reader["GrossMarginRate"] });
            }

            // Close reader. 
            reader.Close();

            // Close database connection.
            connection.Close();
            connection.Dispose();
            this.showTotal();
        }

        private void c1FlexGrid1_OwnerDrawCell(object sender, OwnerDrawCellEventArgs e)
        {
            // Settings meant for GrossMarginRate column only (exclude fixed row and aggregate row).
            if (e.Col == 5 && e.Row >= c1FlexGrid1.Rows.Fixed && e.Row != c1FlexGrid1.Rows.Count -1)
            {
                double value;
                if (double.TryParse(c1FlexGrid1.GetDataDisplay(e.Row, e.Col), NumberStyles.Any, CultureInfo.CurrentCulture, out value))
                {
                    // Calculate the horizontal width. 
                    //Rectangle rc = e.Bounds;
                    Rectangle rc = this.c1FlexGrid1.GetCellRect(e.Row, 5);
                    rc.Width = (int)(this.c1FlexGrid1.Cols[e.Col].WidthDisplay * value);

                    // Draw background of the cell.
                    e.DrawCell(DrawCellFlags.Background | DrawCellFlags.Border);

                    // Draw a bar graph. 
                    rc.Inflate(-1, -1);
                    e.Graphics.FillRectangle(Brushes.LimeGreen, rc);
                    rc.Inflate(-1, -1);
                    e.Graphics.FillRectangle(Brushes.PaleGreen, rc);

                    // Draw contents of the cell. 
                    e.DrawCell(DrawCellFlags.Content);
                }
            }
        }

        private void c1FlexGrid1_DoubleClick(object sender, EventArgs e)
        {
            if (this.c1FlexGrid1.Row < 0 || this.c1FlexGrid1.GetDataDisplay(this.c1FlexGrid1.Row, 0).Length == 0)
            {
                return;
            }

            InputForm input = new InputForm();
            input.Category = this.category;
            int rowNum = this.c1FlexGrid1.Row;

            input.Date = DateTime.Parse( this.c1FlexGrid1[rowNum, 0].ToString() );
            input.CategoryCode = this.c1FlexGrid1[rowNum, 1];
            input.Proceeds = this.c1FlexGrid1[rowNum, 2] == null ? 0 : int.Parse(this.c1FlexGrid1[rowNum, 2].ToString());
            input.Payments = this.c1FlexGrid1[rowNum, 3] == null ? 0 : int.Parse(this.c1FlexGrid1[rowNum, 3].ToString());

            if (input.ShowDialog() == DialogResult.OK)
            {
                this.c1FlexGrid1[rowNum, 0] = input.Date.Date;
                this.c1FlexGrid1[rowNum, 1] = input.CategoryCode;
                this.c1FlexGrid1[rowNum, 2] = input.Proceeds;
                this.c1FlexGrid1[rowNum, 3] = input.Payments;
            }
            input.Dispose();

            this.calcGrossMargin(rowNum);
        }
        
        /// <summary>
        /// Calculate gross margin rate. 
        /// </summary>
        /// <param name="rowNum"></param>
        private void calcGrossMargin(int rowNum)
        {
            double proceeds = this.c1FlexGrid1[rowNum, 2] == null
                    ? 0 : double.Parse(this.c1FlexGrid1[rowNum, 2].ToString());
            double payments = this.c1FlexGrid1[rowNum, 3] == null
                    ? 0 : double.Parse(this.c1FlexGrid1[rowNum, 3].ToString());
            double grossMargin = proceeds - payments;
            this.c1FlexGrid1[rowNum, 4] = grossMargin;
            this.c1FlexGrid1[rowNum, 5] = proceeds != 0 ? grossMargin / proceeds : 0;

            this.showTotal();
        }

        /// <summary>
        /// Add the data. 
        /// </summary>
        private void addData()
        {
            InputForm input = new InputForm();
            input.Category = this.category;

            if (input.ShowDialog() == DialogResult.OK)
            {
                int rowNumber = this.c1FlexGrid1.AddItem(new object[] { input.Date.Date, input.CategoryCode, input.Proceeds, input.Payments }).Index;
                this.calcGrossMargin(rowNumber);
            }
            input.Dispose();
        }

        /// <summary>
        /// Click on the Read button.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ribbonButton1_Click(object sender, EventArgs e)
        {
            this.loadDatabase();
        }

        /// <summary>
        /// Click on the Write button. 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ribbonButton2_Click(object sender, EventArgs e)
        {
            this.writeDatabase();
        }

        /// <summary>
        /// Click on Add data button.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ribbonButton4_Click(object sender, EventArgs e)
        {
            this.addData();
        }

        /// <summary>
        /// PDF Output
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ribbonButton3_Click(object sender, EventArgs e)
        {
            this.createPdfFile();
        }

        /// <summary>
        /// Create a PDF file. 
        /// </summary>
        private void createPdfFile()
        {
            // Create a PDF document. 
            this.c1PdfDocument1.Clear();
            string title = string.Format("Sales Data for {0}", CultureInfo.CurrentCulture.DateTimeFormat.GetMonthName(this.dateTimePicker1.Value.Month));
            this.c1PdfDocument1.DocumentInfo.Title = title;

            // Set password. 
            if (this.ribbonCheckBox1.Checked)
                this.setPassword();

            // Calculate the page area and decide the rendering area（Set margins for top, bottom, left, right). 
            RectangleF rcPage = this.c1PdfDocument1.PageRectangle;
            rcPage.Inflate(-100, -100);
            RectangleF rc = rcPage;

            // Draw title. 
            rc = this.drawTitle(title, rc);

            // Draw grid data.  
            this.drawGridData(rc, rcPage, string.Empty, new string[] { "Date", "Product Category", "Proceeds", "Payments", "GrossMargin", "GrossMarginRate" });

            // Save and display the document. 
            string fileName = DateTime.Now.ToString("yyyyMMddhhmmss") + ".pdf";
            this.c1PdfDocument1.Save(fileName);
            Process.Start(fileName);
        }

        /// <summary>
        /// Set password in PDF file. 
        /// </summary>
        private void setPassword()
        {
            c1PdfDocument1.FontType = C1.C1Pdf.FontTypeEnum.Embedded;
            this.c1PdfDocument1.Security.UserPassword = this.ribbonEditBox1.Text;
        }

        /// <summary>
        /// Draw the title and return the display area. 
        /// </summary>
        /// <param name="title"></param>
        /// <param name="rc"></param>
        /// <returns></returns>
        private RectangleF drawTitle(string title, RectangleF rc)
        {
            Font font = new Font("MS UI Gothic", 14, FontStyle.Bold);
            // Get and set the height. 
            rc.Height = this.c1PdfDocument1.MeasureString(title, font, rc.Width).Height;

            // Draw title. 
            this.c1PdfDocument1.DrawString(title, font, Brushes.Black, rc);

            // Adjust the drawing location.
            rc.Offset(0, rc.Height + 5);
            return rc;
        }

        private void drawGridData(RectangleF rc, RectangleF rcPage, string source, string[] fields)
        {
            // Select font. 
            Font headerFont = new Font("MS UI Gothic", 10, FontStyle.Bold);
            Font dataFont = new Font("MS UI Gothic", 8);

            // Draw header rows (fixed rows). 
            rc = this.drawHeaderRow(headerFont, rc, fields);

            // Draw data rows (except for fixed rows). 
            for (int i = 1; i < this.c1FlexGrid1.Rows.Count; i++)
            {
                rc = this.drawDataRow(dataFont, headerFont, rcPage, rc, fields, i);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="font"></param>
        /// <param name="rc"></param>
        /// <param name="fields"></param>
        /// <returns></returns>
        private RectangleF drawHeaderRow(Font font, RectangleF rc, string[] fields)
        {
            // Measure cell width (all columns have the same width). 
            RectangleF rcCell = rc;
            rcCell.Width = rc.Width / fields.Length;
            rcCell.Height = 0;

            // Measure cell height (highest value among all the columns within a row). 
            foreach (string field in fields)
            {
                float height = this.c1PdfDocument1.MeasureString(field, font, rcCell.Width).Height;
                rcCell.Height = Math.Max(rcCell.Height, height);
            }

            // Draw header.
            foreach (string field in fields)
            {
                this.c1PdfDocument1.FillRectangle(Brushes.Black, rcCell);
                this.c1PdfDocument1.DrawString(field, font, Brushes.White, rcCell);
                // Position is set by adjusting the horizontal width only. 
                rcCell.Offset(rcCell.Width, 0);
            }

            // Adjust the drawing location. 
            rc.Offset(0, rcCell.Height);
            return rc;
        }


        private RectangleF drawDataRow(Font font, Font headerFont, RectangleF rcPage, RectangleF rc, string[] fields, int rowNum)
        {
            // Measure cell width (all columns have the same width). 
            RectangleF rcCell = rc;
            rcCell.Width = rc.Width / fields.Length;
            rcCell.Height = 0;
            rcCell.Inflate(-4, 0);

            //  Measure cell height (highest value among all the columns within a row). 
            for (int i = 0; i < this.c1FlexGrid1.Cols.Count; i++ )
            {
                string value = this.c1FlexGrid1.GetDataDisplay(rowNum, i);
                float height = this.c1PdfDocument1.MeasureString(value, font, rcCell.Width).Height;
                rcCell.Height = Math.Max(rcCell.Height, height);
            }
            rcCell.Inflate(4, 0);

            // Set page break as required. 
            if (rcCell.Bottom > rcPage.Bottom)
            {
                this.c1PdfDocument1.NewPage();
                rc = this.drawHeaderRow(headerFont, rcPage, fields);
                rcCell.Y = rc.Y;
            }

            // Align text vertically in the center.
            StringFormat sf = new StringFormat();
            sf.LineAlignment = StringAlignment.Center;

            // Draw data cell. 
            Pen pen = new Pen(Brushes.Gray, 0.1f);

            for (int i = 0; i < this.c1FlexGrid1.Cols.Count; i++)
            {
                // Get grid data. 
                string value = this.c1FlexGrid1.GetDataDisplay(rowNum, i);

                // Align right in case of numeric values, otherwise align left.  
                double d;
                sf.Alignment = (double.TryParse(value, out d)) ? StringAlignment.Far : StringAlignment.Near;

                // Draw cell.
                this.c1PdfDocument1.DrawRectangle(pen, rcCell);
                rcCell.Inflate(-4, 0);

                // Draw data in the cell. 
                this.c1PdfDocument1.DrawString(value, font, Brushes.Black, rcCell, sf);
                rcCell.Inflate(4, 0);

                // Position is set by adjusting the horizontal width only.
                rcCell.Offset(rcCell.Width, 0);
            }
            pen.Dispose();

            // Adjust the drawing position. 
            rc.Offset(0, rcCell.Height);
            return rc;
        }

        private void ribbonButton5_Click(object sender, EventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Filter = "(*.xls)|*.xls";

            if ( dialog.ShowDialog() == DialogResult.OK )
            {
                // Save Excel file.
                this.c1FlexGrid1.SaveExcel(dialog.FileName, "GridData", FileFlags.IncludeFixedCells | FileFlags.AsDisplayed);
                Process.Start(dialog.FileName);
            }
            dialog.Dispose();
        }

        private void ribbonButton7_Click(object sender, EventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Filter = "(*.xml)|*.xml";

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                // Export to Xml file.
                this.c1FlexGrid1.WriteXml(dialog.FileName);
            }
        }

        private void ribbonButton8_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "(*.xml)|*.xml";

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                // Import Xml file.
                this.c1FlexGrid1.ReadXml(dialog.FileName);
            }
        }

        private void ribbonButton6_Click(object sender, EventArgs e)
        {
            this.printGrid();
        }

     
    }
}   
